<?php // $Id: resource.class.php,v 1.25.4.1 2009/02/03 18:30:28 eLS $
require_once($CFG->libdir.'/formslib.php');

class resource_tree extends resource_base {
    function resource_tree($cmid=0) {
        parent::resource_base($cmid);
    }
    
    function add_instance($resource) {
        $resource->alltext .= "<!-- id -->";
        $this->_postprocess($resource);
        return parent::add_instance($resource);
    }

    function tree_add_instance(&$resource) {
        $resource->alltext .= "<!-- id -->";
        $resource->timemodified = time();
        if (!isset($resource->groupingid)) {
            $resource->groupingid = 0;
        }
        if (!isset($resource->groupmembersonly)) {
            $resource->groupmembersonly = 0;
        }
        if (!isset($resource->name)) { 
            $resource->name = $resource->modulename;
        }
        if (!isset($resource->alltext)) { 
            $resource->alltext = "";
        }
        if (!isset($resource->summary)) { 
            $resource->summary = "";
        }
        if (!isset($resource->popup)) { 
            $resource->popup = "";
        }
        if (!isset($resource->score)) { 
            $resource->score = 0;
        }
        if (!isset($resource->indent)) { 
            $resource->indent = 0;
        }
        if (!isset($resource->visible)) { 
            $resource->visible = 1;
        }
        if (!isset($resource->visibleold)) { 
            $resource->visibleold = 1;
        }
        if (!empty($course->groupmodeforce) or !isset($resource->groupmode)) {
            $resource->groupmode = 0; // do not set groupmode
            $resource->groupingid = 0; 
            $resource->groupmembersonly = 0; 
        }
        if (!course_allowed_module($resource->course,$resource->modulename)) {
            error("This module ($resource->modulename) has been disabled for this particular course");
        }
        $this->_postprocess($resource);
        //echo "<pre>ADD LINK<br>";
        //var_dump($resource);
        //die;
        //return parent::add_instance($resource);
        if(!$resource->instance = insert_record("resource", $resource)){
            //var_dump($resource);
            error("Tree: insert error");
        }
        if(!isset($resource->parent)){
            if (! $resource->coursemodule = add_course_module($resource) ) {
                error("Could not add a new course module");
            }
            if (! $sectionid = add_mod_to_section($resource) ) {
                error("Could not add the new course module to that section");
            }

            if (! set_field("course_modules", "section", $sectionid, "id", $resource->coursemodule)) {
                error("Could not update the course module with the correct section");
            }
        

            // make sure visibility is set correctly (in particular in calendar)
            set_coursemodule_visible($fromform->coursemodule, $fromform->visible);

            if (isset($resource->cmidnumber)) { //label
                // set cm idnumber
                set_coursemodule_idnumber($fromform->coursemodule, $fromform->cmidnumber);
            }
            add_to_log($course->id, "course", "add mod",
                       "../mod/$fromform->modulename/view.php?id=$fromform->coursemodule",
                       "$fromform->modulename $fromform->instance");
            add_to_log($course->id, $fromform->modulename, "add",
                       "view.php?id=$fromform->coursemodule",
                       "$fromform->instance", $fromform->coursemodule);
        }else{
            if(isset($resource->section)){
                $section = get_record('course_sections','course',$resource->course,'section',$resource->section);
                $resource->section = $section->id;
            }else{
                $resource->section = 0;
            }
            if (!isset($resource->cmidnumber)) {
                $resource->cmidnumber = "";
            }
            $resource->added = time();
            if(!$resource->coursemodule = insert_record("course_modules",$resource)){
                error("Tree:CM insert error");
            }
        }
    }
    
    function tree_update_parent($parent,$child,$position){
        /*if(!$parentcm = get_record("course_modules", "id",$parent)){
            error("Tree:Parent cmid invalid");
        }*/
        if(!$cm = get_record("course_modules","id",$parent)){
            error("Tree:Parent cm not found");
        }
        if(!$parentdata = get_record("resource","id",$cm->instance)){
            error("Tree:Parent not found");
        }
        $this->quote_decode($parentdata);
        $alltext = explode("<!-- id -->",$parentdata->alltext);
        $parentdata->alltext = $alltext[0]."<!-- id -->";
        if($alltext[1]){
            $this->singlecolon($alltext[1]);
            $treeids = explode(":",$alltext[1]);
            $this->array_insert(&$treeids,$child,$position);
            foreach($treeids as $treeid){
                if($lasttreeid != $treeid){
                    if($treeid){
                        $parentdata->alltext .= $treeid.":";
                        $lasttreeid = $treeid;
                    }
                }
            }
        }else{
            $parentdata->alltext .= $child.":";
        }
        $this->quote_replace($parentdata);
        /*echo "<pre>";
        var_dump($parentdata);
        echo "</pre>";*/
        if(!$parent = update_record("resource",$parentdata)){
            error("Tree:Parent update error");
        }
    }
    
    function array_insert ( &$array, $insert, $pos ) {
        if (!is_array($array)) return false;
        $last = array_splice($array, $pos);
        array_push($array, $insert);
        $array = array_merge($array, $last);
        return true;
    }

    function update_instance($resource) {
        $this->_postprocess($resource);
        return parent::update_instance($resource);
    }

    function tree_update_instance(&$resource) {
        $this->_postprocess($resource);
        if(!$cm = get_record("course_modules","id",$resource->updatetree)){
            error("Tree:lastcm no fond");
        }
        $resource->coursemodule = $cm->id;
        if(!$lastdata = get_record("resource","id",$cm->instance)){
            error("Tree:lastdata not found");
        }
        $this->quote_decode($resource);
        $alltext = explode("<!-- id -->",$lastdata->alltext);
        $resource->alltext .= "<!-- id -->";
        if($alltext[1]){
            $this->singlecolon($alltext[1]);
            $treeids = explode(":",$alltext[1]);
            foreach($treeids as $treeid){
                if($treeid){
                    $resource->alltext .= $treeid.":";
                }
            }
        }
        //var_dump($resource);
        $this->quote_replace($resource);
        if(!$upchk = update_record("resource",$resource)){
            error("Tree:Update error");
        }
        if($resource->textblock){
            foreach($resource->textblock as $key=>$blocktext){
                if($key!="new"){
                    $updateblock->id = $key;
                    $updateblock->alltext = $blocktext;
                    if(!update_record("resource",$updateblock)){
                        error("Tree:Textblock Update error");
                    }
                }
            }
        }
    }

    function _postprocess(&$resource) {
        global $RESOURCE_WINDOW_OPTIONS;
        $alloptions = $RESOURCE_WINDOW_OPTIONS;

        if ($resource->windowpopup) {
            $optionlist = array();
            foreach ($alloptions as $option) {
                $optionlist[] = $option."=".$resource->$option;
                unset($resource->$option);
            }
            $resource->popup = implode(',', $optionlist);
            unset($resource->windowpopup);
            $resource->options = '';

        } else {
            if (empty($resource->blockdisplay)) {
                $resource->options = '';
            } else {
                $resource->options = 'showblocks';
            }
            unset($resource->blockdisplay);
            $resource->popup = '';
        }
    }


    function display() {
        global $CFG;
        $parentid = optional_param('parentid', 0);
        $formatoptions = new object();
        $formatoptions->noclean = true;

        /// Set up some shorthand variables
        $cm = $this->cm;
        $course = $this->course;
        $resource = $this->resource;
        // fix for MDL-9021, thanks Etienne Roz
        // fix for MDL-15387, thanks to John Beedell
        add_to_log($course->id, "resource", "view", "view.php?id={$cm->id}", $resource->id, $cm->id);
        
        $pagetitle = strip_tags($course->shortname.': '.format_string($resource->name));
        $inpopup = optional_param('inpopup', '', PARAM_BOOL);
        $alltext = explode("<!-- id -->",$resource->alltext);
        $this->singlecolon($alltext[1]);
        $treeids = explode(":",$alltext[1]);
        $strmodulenameplural = get_string("modulenameplural", "resource");
        $strbacktoparent = get_string("parent","resource");
        $strlastmodified = get_string("lastmodified");
        
        $navlinks = array();
        $navlinks[] = array('name' => $strmodulenameplural, 'link' => "$CFG->wwwroot/mod/resource/index.php?id=$course->id", 'type' => 'activity');
        
        if($parentid){
            $this->singlecolon($parentid);
            $parentids = explode(":",$parentid);
            $cnt = count($parentids);
            $lastparent = $parentids[$cnt-2];
            foreach($parentids as $pid){
                if(!$pcm = get_record("course_modules","id",trim($pid))){
                    error("Tree:get cm $treeid error");
                }
                if(!$pdata = get_record("resource","id",$pcm->instance)){
                    error("Tree:get data $treecm->id error");
                }
                $this->quote_decode($pdata);
                if($pid==$lastparent){
                    //$parented .= $pid.":";
                    $navlinks[] = array('name' => $pdata->name, 'link' => "$CFG->wwwroot/mod/resource/view.php?id=$pid&parentid=$parented", 'type' => 'activity');
                    break;
                }else{
                    $navlinks[] = array('name' => $pdata->name, 'link' => "$CFG->wwwroot/mod/resource/view.php?id=$pid&parentid=$parented", 'type' => 'activity');
                    $parented .= $pid.":";
                }
            }
            $backtoparent = "<a href=\"$CFG->wwwroot/mod/resource/view.php?id=$lastparent&parentid=$parented\">".$strbacktoparent."</a>";
            $parents = $parentid.$cm->id.":";
        }else{
            $parents = $cm->id.":";
        }
        
        $navlinks[] = array('name' => $resource->name, 'link' => "", 'type' => 'activity');
        
        /// Are we displaying the course blocks?
        if ($this->resource->options == 'showblocks') {

            parent::display_course_blocks_start();

            //echo format_text($alltext[0], FORMAT_HTML, $formatoptions, $this->course->id);
            echo $backtoparent;
            print_simple_box(format_text($alltext[0], FORMAT_HTML, $formatoptions, $course->id), "center clearfix", "", "", "20");
            
            foreach($treeids as $treeid){
                if($treeid){
                    if(!$treecm = get_record("course_modules","id",trim($treeid))){
                        error("Tree:get cm $treeid error");
                    }
                    if(!$treedata = get_record("resource","id",$treecm->instance)){
                        error("Tree:get data $treecm->id error");
                    }
                    $this->quote_decode($treedata);
                    if($treedata->name){
                        echo "<p><a href=\"$CFG->wwwroot/mod/resource/view.php?id=$treeid&parentid=$parents\">".$treedata->name."</a></p>";
                    }else{
                        print_simple_box(format_text($treedata->alltext, FORMAT_HTML, $formatoptions, $course->id),
                        "center clearfix", "", "", "20");
                    }
                }
            }

            echo "<div class=\"modified\">$strlastmodified: ".userdate($resource->timemodified)."</div>";


            parent::display_course_blocks_end();

        } else {

            /// Set up generic stuff first, including checking for access
            //parent::display();
            $navigation = build_navigation($navlinks);
            print_header($pagetitle, $course->fullname, $navigation,
                    "", "", true,"",// update_module_button($cm->id, $course->id, $this->strresource),
                    navmenu($course, $cm));
            echo $backtoparent;
            if ($resource->popup) {
                if ($inpopup) {                    /// Popup only
                    
                    //print_header();
                    print_simple_box(format_text($alltext[0], FORMAT_HTML, $formatoptions, $course->id),
                            "center clearfix", "", "", "20");
                    foreach($treeids as $treeid){
                        if($treeid){
                            if(!$treecm = get_record("course_modules","id",trim($treeid))){
                                error("Tree:get cm $treeid error");
                            }
                            if(!$treedata = get_record("resource","id",$treecm->instance)){
                                error("Tree:get data $treecm->id error");
                            }
                            $this->quote_decode($treedata);
                            if($treedata->name){
                                echo "<p><a href=\"$CFG->wwwroot/mod/resource/view.php?id=$treeid&parentid=$parents\">".$treedata->name."</a></p>";
                            }else{
                                print_simple_box(format_text($treedata->alltext, FORMAT_HTML, $formatoptions, $course->id),
                                "center clearfix", "", "", "20");
                            }
                        }
                    }
                    echo "<div class=\"modified\">$strlastmodified: ".userdate($resource->timemodified)."</div>";
                    print_footer($course);
                    exit;
                } else {                           /// Make a page and a pop-up window
                    /*$navigation = build_navigation($this->navlinks, $cm);
                    
                    print_header($pagetitle, $course->fullname, $navigation,
                            "", "", true, update_module_button($cm->id, $course->id, $this->strresource),
                            navmenu($course, $cm));*/

                    echo "\n<script type=\"text/javascript\">";
                    echo "\n//<![CDATA[\n";
                    echo "openpopup('/mod/resource/view.php?inpopup=true&id={$cm->id}&parentid=$parentid','resource{$resource->id}','{$resource->popup}');\n";
                    echo "\n//]]>\n";
                    echo '</script>';

                    if (trim(strip_tags($resource->summary))) {
                        print_simple_box(format_text($resource->summary, FORMAT_MOODLE, $formatoptions, $course->id), "center clearfix");
                    }

                    $link = "<a href=\"$CFG->wwwroot/mod/resource/view.php?inpopup=true&amp;id={$cm->id}&amp;parentid=$parents\"\" onclick=\"this.target='resource{$resource->id}'; return openpopup('/mod/resource/view.php?inpopup=true&amp;id={$cm->id}', 'resource{$resource->id}','{$resource->popup}');\">".format_string($resource->name,true)."</a>";

                    echo '<div class="popupnotice">';
                    print_string('popupresource', 'resource');
                    echo '<br />';
                    print_string('popupresourcelink', 'resource', $link);
                    echo '</div>';

                    print_footer($course);
                    exit;
                }
            } else {    /// not a popup at all
                /*$navigation = build_navigation($this->navlinks, $cm);
                
                print_header($pagetitle, $course->fullname, $navigation,
                        "", "", true, update_module_button($cm->id, $course->id, $this->strresource),
                        navmenu($course, $cm));
                */
                print_simple_box(format_text($alltext[0], FORMAT_HTML, $formatoptions, $course->id), "center clearfix", "", "", "20");

                foreach($treeids as $treeid){
                    if($treeid){
                        if(!$treecm = get_record("course_modules","id",trim($treeid))){
                            error("Tree:get cm $treeid error");
                        }
                        if(!$treedata = get_record("resource","id",$treecm->instance)){
                            error("Tree:get data $treecm->id error");
                        }
                        $this->quote_decode($treedata);
                        if($treedata->name){
                            echo "<p><a href=\"$CFG->wwwroot/mod/resource/view.php?id=$treeid&parentid=$parents\">".$treedata->name."</a></p>";
                        }else{
                            print_simple_box(format_text($treedata->alltext, FORMAT_HTML, $formatoptions, $course->id),
                            "center clearfix", "", "", "20");
                        }
                    }
                }

                echo "<div class=\"modified\">$strlastmodified: ".userdate($resource->timemodified)."</div>";

                print_footer($course);
                exit;
            }

        }

    }

    function setup_preprocessing(&$defaults){

        if (!isset($defaults['popup'])) {
            // use form defaults

        } else if (!empty($defaults['popup'])) {
            $defaults['windowpopup'] = 1;
            if (array_key_exists('popup', $defaults)) {
                $rawoptions = explode(',', $defaults['popup']);
                foreach ($rawoptions as $rawoption) {
                    $option = explode('=', trim($rawoption));
                    $defaults[$option[0]] = $option[1];
                }
            }
        } else {
            $defaults['windowpopup'] = 0;
            if (array_key_exists('options', $defaults)) {
                $defaults['blockdisplay'] = ($defaults['options']=='showblocks');
            }
        }
    }

    function setup_elements(&$mform) {
        global $CFG, $RESOURCE_WINDOW_OPTIONS ,$sesskey;
        $section = optional_param('section', PARAM_INT);
        $course = optional_param('course', PARAM_INT);
        $addlink = optional_param('addlink', 0);
        $addtext = optional_param('addtext', 0);
        $add = optional_param('add', 0, PARAM_ALPHA);
        $update = optional_param('update', 0, PARAM_INT);
        $saveback = optional_param('saveback', 0);
        $treetime = time();
        $fromform = $this->tree_get_postdata($_POST);
        if($fromform->cancel){
            $_SESSION["treetime"] = $treetime;
            unset($_SESSION["treeid"] );
            redirect($CFG->wwwroot."/course/view.php?id=".$fromform->course,0);
        }
        if($add){
            if (! $course = get_record("course", "id", $course)) {
                error("This course doesn't exist");
            }
            if($fromform){
                if($fromform->edit){
                    $editbutton = true;
                    $updatechild = array_keys($fromform->edit);
                    $fromform->updatechild = $updatechild[0];
                    $_SESSION["treeid"] = $fromform->updatetree;
                }elseif($fromform->delete_){
                    $editbutton = true;
                    $deletechild = array_keys($fromform->delete_);
                    $fromform->deletechild = $deletechild[0];
                    if(!$oldcm = get_record("course_modules","id",$fromform->updatetree)){
                        error("Tree:Delete cm invalid");
                    }
                    if(!$olddata = get_record("resource","id",$oldcm->instance)){
                        error("Tree:Delete record invalid");
                    }
                    $this->quote_decode($olddata);
                    $alltext = explode("<!-- id -->",$olddata->alltext);
                    $this->singlecolon($alltext[1]);
                    $treeids = explode(":",$alltext[1]);
                    $olddata->alltext = $alltext[0]."<!-- id -->";
                    foreach($treeids as $treeid){
                        if($treeid != $deletechild[0] && $treeid){
                            $olddata->alltext .= $treeid.":";
                        }
                    }
                    if(!$delcm = get_record("course_modules","id",$fromform->deletechild)){
                        error("Tree:Delete cm is nothing");
                    }
                    if(!delete_records("resource","id",$delcm->instance)){
                        error("Tree:Delete child data is nothing");
                    }
                    if(!$chk = update_record("resource",$olddata)){
                        error("Tree:Delete record update error");
                    }
                    $_SESSION["treeid"] = $fromform->updatetree;
                }elseif($fromform->movehere){
                    $editbutton = true;
                    $movehere = array_keys($fromform->movehere);
                    if(!$movecm = get_record("course_modules","id",$fromform->updatetree)){
                        error("Tree:Move cm is nothing");
                    }
                    if(!$movedata = get_record("resource","id",$movecm->instance)){
                        error("Tree:Move child data is nothing");
                    }
                    $alltext = explode("<!-- id -->",$movedata->alltext);
                    $this->singlecolon($alltext[1]);
                    $treeids = explode(":",$alltext[1]);
                    $movedata->alltext = $fromform->alltext."<!-- id -->";
                    for($i=0;$i<count($treeids);$i++){
                        if($i==$movehere[0]){
                            $movedata->alltext .= $fromform->moveid.":";
                        }
                        if($treeids[$i] && $treeids[$i]!=$fromform->moveid){
                            $movedata->alltext .= $treeids[$i].":";
                        }
                    }
                    if($_SESSION["treetime"] == $fromform->treetime){
                        if(!$chk = update_record("resource",$movedata)){
                            error("Tree:Update error");
                        }
                    }
                    unset($newdata);
                    $_SESSION["treeid"] = $fromform->updatetree;
                }elseif($fromform->hide){
                    $editbutton = true;
                    $hidechild = array_keys($fromform->hide);
                    $fromform->hidechild = $hidechild[0];
                    if(!$hidechild = set_field("course_modules","visible",0,"id",$hidechild[0])){
                        error("Tree:Hide set error");
                    }
                    /*
                    if(!$hidecm = get_record("course_modules","id",$fromform->hidechild)){
                        error("Tree:Hide cm is nothing");
                    }
                    if(!$hidedata = get_record("resourece","id",$hidecm->instance)){
                        error("Tree:Hide child data is nothing");
                    }
                    */
                    $_SESSION["treeid"] = $fromform->updatetree;
                }
                if($fromform->textblock["new"]){
                    if($_SESSION["treetime"] == $fromform->treetime){
                        $newblockdata->name = "";
                        $newblockdata->course = $fromform->course;
                        $newblockdata->type = "tree";
                        $newblockdata->reference = "";
                        $newblockdata->summary = "";
                        $newblockdata->alltext = $fromform->textblock["new"];
                        $newblockdata->popup = "";
                        $newblockdata->options = "";
                        $newblockdata->timemodified = time();
                        $newblockdata->parent = $fromform->updatetree;
                        if(!$blockcm->instance =  insert_record("resource",$newblockdata)){
                            error("Tree:New block insert error");
                        }
                        if(isset($fromform->section)){
                            $section = get_record('course_sections','course',$resource->course,'section',$resource->section);
                            $resource->section = $section->id;
                        }else{
                            $resource->section = 0;
                        }
                        $blockcm->module = $fromform->module;
                        $blockcm->course = $fromform->course;
                        $blockcm->section = $fromform->section;
                        $blockcm->added = time();
                        $blockcm->visible = 1;
                        $blockcm->visibleold = 1;
                        $blockcm->indent = 0;
                        $blockcm->score = 0;
                        $blockcm->groupmode = 0; // do not set groupmode
                        $blockcm->groupingid = 0; 
                        $blockcm->groupmembersonly = 0; 
                        $blockcm->cmidnumber = "";
                        if(!$newblockcm = insert_record("course_modules",$blockcm)){
                            error("Tree:New block cm insert error");
                        }
                    }
                    if(!$oldcm = get_record("course_modules","id",$fromform->updatetree)){
                        error("Tree:Own cm invalid");
                    }
                    if(!$olddata = get_record("resource","id",$oldcm->instance)){
                        error("Tree:own data is invalid");
                    }
                    $this->quote_decode($treedata);
                    $alltext = explode("<!-- id -->",$olddata->alltext);
                    $newdata = clone $fromform;
                    $newdata->alltext .= "<!-- id -->";
                    $this->singlecolon($alltext[1]);
                    $treeids = explode(":",$alltext[1]);
                    $this->array_insert($treeids,$newblockcm,$newdata->newposition);
                    foreach($treeids as $treeid){
                        if($treeid){
                            $newdata->alltext .= $treeid.":";
                        }
                    }
                    $newdata->id = $olddata->id;
                    $this->quote_replace($treedata);
                    if($_SESSION["treetime"] == $newdata->treetime){
                        if(!$chk = update_record("resource",$newdata)){
                            error("Tree:Update error");
                        }
                    }
                    unset($newdata);
                }
                //echo "TEXT=".$fromform->alltext .":TEXT<br/>";
                if($_SESSION["treetime"] == $fromform->treetime && !$deletechild){
                    if($fromform->updatetree>0 && !$deletechild){
                        //$fromform->id = $fromform->updatetree;
                        $this->tree_update_instance($fromform);
                        $_SESSION["treeid"] = $fromform->coursemodule;
                    }else{
                        $this->tree_add_instance($fromform);
                        $_SESSION["treeid"] = $fromform->coursemodule;
                    }
                   
                }
                if(isset($fromform->addtext)){
                    $position = array_keys($fromform->addtext);
                }
                //Parent ids
                if($fromform->parent){
                    if($saveback){
                        $this->singlecolon($fromform->parent);
                        $parents = explode(":",$fromform->parent);
                        $parents = array_unique($parents);
                        $limit = count($parents)-1;
                        if($limit==0){
                            $lastparent = $parents[$limit];
                        }else{
                            $lastparent = $parents[$limit-1];
                            for($i=0;$i<=$limit;$i++){
                                if($parents[$i]!=$fromform->updatetree){
                                    if($i==$limit){
                                        $lastparent = $parents[$i];
                                    }elseif($i==0){
                                        $parent = $parents[$i];
                                    }else{
                                        if($parents[$i]!=$parents[$i-1]){
                                            $parent .= ":".$parents[$i];
                                        }
                                    }
                                }
                                if(!isset($lastparent) && isset($parent)){
                                    $lastparent = $parent;
                                }
                            }
                        }
                    }else{
                        $parents = explode(":",$fromform->parent);
                        $parents = array_unique($parents);
                        $limit = count($parents)-1;
                        $lastparent = $parents[$limit];
                        $parent = $fromform->parent . ":" .$_SESSION["treeid"];
                    }
                }else{
                    $parent = $_SESSION["treeid"];
                }
                if($fromform->addtext || $deletechild || $hidechild || $fromform->move || $fromform->movehere){
                    //Nothing to do.
                    $parent = $fromform->parent;
                }
                if($_SESSION["treetime"] == $fromform->treetime && !$fromform->editbuck){
                    if(isset($lastparent) && $fromform->position!="none"){
                        $this->tree_update_parent($lastparent,$_SESSION["treeid"],$fromform->position);
                    }
                }
                if($fromform->treesubmitbutton2){
                    $_SESSION["treetime"] = $treetime;
                    unset($_SESSION["treeid"] );
                    redirect($CFG->wwwroot."/course/view.php?id=".$fromform->course,0);
                }elseif($fromform->treesubmitbutton){
                    $_SESSION["treetime"] = $treetime;
                    $id = $_SESSION["treeid"];
                    unset($_SESSION["treeid"] );
                    redirect($CFG->wwwroot."/mod/resource/view.php?id=".$id,0);
                }
                $this->reset_mform($mform);
                if($editbutton){
                    $mform->addElement('hidden', 'editbuck', 'true');
                }
                $mform->addElement('hidden', 'type', 'tree');
                $mform->setDefault('type', 'tree');
                $mform->addElement('hidden', 'parent', 0);
                $mform->setDefault('parent',$parent);
                $mform->addElement('header', 'general', get_string('general', 'form'));
                $mform->addElement('text', 'name', get_string('name'), array('size'=>'48'));
                $mform->addElement('hidden', 'position', 0);
                if($fromform->addlink){
                    $position = array_keys($fromform->addlink);
                    $mform->setDefault('position',$position[0]);
                }else{
                    $mform->setDefault('position','none');
                }
                if (!empty($CFG->formatstringstriptags)) {
                    $mform->setType('name', PARAM_TEXT);
                } else {
                    $mform->setType('name', PARAM_CLEAN);
                }
                $mform->addRule('name', null, 'required', null, 'client');
            }
            $mform->addElement('hidden', 'treetime', 0);
            $mform->setDefault('treetime', $treetime);
            $this->tree_hidden_coursemodule_elements($mform);
            if($saveback){
                if(!$treecm = get_record("course_modules","id",$lastparent)){
                    error("Tree:own cm invalid");
                }
                if(!$treedata = get_record("resource","id",$treecm->instance)){
                    error("Tree:Parent Record is nothing");
                }
            }elseif($fromform->addtext || $hidechild ||$fromform->move || $fromform->movehere){
                if(!$treecm = get_record("course_modules","id",$_SESSION["treeid"])){
                    error("Tree:own cm invalid");
                }
                if(!$treedata = get_record("resource","id",$treecm->instance)){
                    error("Tree:own data is invalid");
                }
                if($fromform->addtext){
                    $alltext = explode("<!-- id -->",$treedata->alltext);
                    $treedata->alltext = $alltext[0]."<!-- id -->";
                    $this->singlecolon($alltext[1]);
                    $treeids = explode(":",$alltext[1]);
                    $this->array_insert($treeids,"new",$position[0]);
                    foreach($treeids as $treeid){
                        if($treeid){
                            $treedata->alltext .= $treeid.":";
                        }
                    }
                }
            }elseif($fromform->updatechild){
                if(!$treecm = get_record("course_modules","id",$fromform->updatechild)){
                    echo $fromform->updatechild;
                    error("Tree:edit cm invalid");
                }
                if(!$treedata = get_record("resource","id",$treecm->instance)){
                    error("Tree:Child data is invalid");
                }
            }elseif($deletechild){
                $treedata = $olddata;
                $treecm = $oldcm;
            }
            $this->quote_decode($treedata);
            $mform->addElement('hidden', 'id', 0);
            $mform->setDefault('id', $treedata->id);
            $mform->setDefault('name', $treedata->name);
            $mform->setDefault('summary', $treedata->summary);
            $mform->setDefault('updatetree', $treecm->id);
            
            $alltext = explode("<!-- id -->",$treedata->alltext);
            $mform->setDefault('alltext', $alltext[0]);
            if($fromform->move){
                $moveid = array_keys($fromform->move);
                $mform->addElement('hidden', 'moveid', $moveid[0]);
                $treedata->move = true;
            }
            $this->new_elements($mform,$treedata);
            if($parent[0] || $parent>0){
                $this->add_saveback_buttons($mform);
            }else{
                $this->tree_add_action_buttons($mform,true,null,null);
            }
            $this->tree_print_header($course,$fromform,$parent);
            $mform->display();
            print_footer($course);
            $_SESSION["treetime"] = $treetime;
            exit;
        }elseif($update){
            $mform->addElement('hidden', 'treetime', 0);
            $mform->setDefault('treetime', $treetime);
            if(!$cm = get_record("course_modules","id",$update)){
                error("Tree:Update cm data is nothing");
            }
            if(!$data = get_record("resource","id",$cm->instance)){
                    error("Tree:Update resource data is nothing");
            }
            $this->quote_decode($data);
            $this->tree_hidden_coursemodule_elements($mform);
            $mform->addElement('hidden', 'parent', 0);
            $this->new_elements($mform,$data);
            $mform->addElement('hidden', 'id', 0);
            $mform->setDefault('id', $data->id);
            $mform->setDefault('name', $data->name);
            $mform->setDefault('summary', $data->summary);
            $mform->setDefault('add', "resource");
            $mform->setDefault('updatetree', $update);
            $alltext = explode("<!-- id -->",$data->alltext);
            $mform->setDefault('alltext', $alltext[0]);
            $this->tree_add_action_buttons($mform,true,null,null);
            $this->tree_print_header($course,$fromform,$parent);
            $mform->display();
            print_footer($course);
            $_SESSION["treetime"] = $treetime;
            exit;
        }else{
            $this->new_elements($mform);
        }
    }

    function new_elements(&$mform,$data) {
        global $CFG, $RESOURCE_WINDOW_OPTIONS;
        $addlink = optional_param('addlink', 0);
        $mform->addElement('htmleditor', 'alltext', get_string('fulltext', 'resource'), array('cols'=>85, 'rows'=>30));
        $mform->setType('alltext', PARAM_RAW);
        $mform->setHelpButton('alltext', array('reading', 'writing', 'richtext'), false, 'editorhelpbutton');
        
        $alltext = explode("<!-- id -->",$data->alltext);
        $treeids = explode(":",$alltext[1]);
        $mform->addElement('submit', 'addlink[0]', get_string("addlink","resource"));
        $mform->addElement('submit', 'addtext[0]', get_string("addtext","resource"));
        if($data->move){
            $mform->addElement('image',"movehere[0]","$CFG->wwwroot/pix/movehere.gif");
        }
        if($treeids[0]){
            $i=1;
            foreach($treeids as $treeid){
                if($treeid){
                    if($treeid == "new"){
                        $mform->addElement('htmleditor', 'textblock[new]', get_string('fulltext', 'resource'), array('cols'=>85, 'rows'=>30));
                        $mform->setType('textblock[new]', PARAM_RAW);
                        $mform->setHelpButton('textblock[new]', array('reading', 'writing', 'richtext'), false, 'editorhelpbutton');
                        $mform->addElement('hidden', 'newposition', $i);
                    }else{
                        if(!$cm = get_record("course_modules","id",trim($treeid))){
                            error("Tree:Link cm is invalid");
                        }
                        if(!$tree = get_record("resource","id",$cm->instance)){
                            error("Tree:Link data is invalid");
                        }
                        if($tree->name){
                            $this->tree_edit_button($mform,$tree,$cm);
                        }else{
                            $mform->addElement('htmleditor', "textblock[$tree->id]", get_string('fulltext', 'resource'), array('cols'=>85, 'rows'=>30));
                            $mform->setType("textblock[$tree->id]", PARAM_RAW);
                            $mform->setHelpButton("textblock[$tree->id]", array('reading', 'writing', 'richtext'), false, 'editorhelpbutton');
                            $mform->setDefault("textblock[$tree->id]", $tree->alltext);
                        }
                        if($data->move){
                            $mform->addElement('image',"movehere[$i]","$CFG->wwwroot/pix/movehere.gif");
                        }
                    }
                    $mform->addElement('submit', "addlink[$i]", get_string("addlink","resource"));
                    $mform->addElement('submit', "addtext[$i]", get_string("addtext","resource"));
                    $i++;
                }
            }
        }
        
        $mform->addElement('header', 'displaysettings', get_string('display', 'resource'));

        $woptions = array(0 => get_string('pagewindow', 'resource'), 1 => get_string('newwindow', 'resource'));
        $mform->addElement('select', 'windowpopup', get_string('display', 'resource'), $woptions);

        $mform->addElement('checkbox', 'blockdisplay', get_string('showcourseblocks', 'resource'));
        if($data->options){
            $mform->setDefault('blockdisplay', 1);
        }else{
            $mform->setDefault('blockdisplay', 0);
        }
        $mform->disabledIf('blockdisplay', 'windowpopup', 'eq', '1');
        $mform->setAdvanced('blockdisplay');
        
        if($data->id || $addlink){
            if($data->popup){
                $setoption['windowpopup'] = 1;
            }else{
                $setoption['windowpopup'] = 0;
            }
        }else{
            $mform->setDefault('windowpopup', !empty($CFG->resource_popup));
        }
        $mform->setDefault('windowpopup', $setoption['windowpopup']);

        if(!$data->popup){
            foreach ($RESOURCE_WINDOW_OPTIONS as $option) {
                if ($option == 'height' or $option == 'width') {
                    $mform->addElement('text', $option, get_string('new'.$option, 'resource'), array('size'=>'4'));
                    $mform->setDefault($option, $CFG->{'resource_popup'.$option});
                    $mform->disabledIf($option, 'windowpopup', 'eq', '0');
                } else {
                    $mform->addElement('checkbox', $option, get_string('new'.$option, 'resource'));
                    $mform->setDefault($option, $CFG->{'resource_popup'.$option});
                    $mform->disabledIf($option, 'windowpopup', 'eq', '0');
                }
                $mform->setAdvanced($option);
            }
        }else{
            if (array_key_exists('popup', $data)) {
                $rawoptions = explode(',', $data->popup);
                foreach ($rawoptions as $rawoption) {
                    $option = explode('=', trim($rawoption));
                    $setoption[$option[0]] = $option[1];
                }
            }
            foreach ($RESOURCE_WINDOW_OPTIONS as $option) {
                if ($option == 'height' or $option == 'width') {
                    $mform->addElement('text', $option, get_string('new'.$option, 'resource'), array('size'=>'4'));
                    $mform->setDefault($option, $setoption[$option]);
                    $mform->disabledIf($option, 'windowpopup', 'eq', '0');
                } else {
                    $mform->addElement('checkbox', $option, get_string('new'.$option, 'resource'));
                    $mform->setDefault($option, $setoption[$option]);
                    $mform->disabledIf($option, 'windowpopup', 'eq', '0');
                }
                $mform->setAdvanced($option);
            }
        }
    }
    
    function tree_add_action_buttons(&$mform,$cancel=true, $submitlabel=null, $submit2label=null) {
        if (is_null($submitlabel)) {
            $submitlabel = get_string('savechangesanddisplay');
        }

        if (is_null($submit2label)) {
            $submit2label = get_string('savechangesandreturntocourse');
        }

        //$mform =& $this->_form;

        // elements in a row need a group
        $buttonarray = array();
        if ($submit2label !== false) {
            $buttonarray[] = $mform->createElement('submit', 'treesubmitbutton2', $submit2label);
        }

        if ($submitlabel !== false) {
            $buttonarray[] = $mform->createElement('submit', 'treesubmitbutton', $submitlabel);
        }

        if ($cancel) {
            $buttonarray[] = $mform->createElement('cancel');
        }

        $mform->addGroup($buttonarray, 'buttonar', '', array(' '), false);
        $mform->setType('buttonar', PARAM_RAW);
        $mform->closeHeaderBefore('buttonar');
    }
    
    function tree_edit_button(&$mform,$tree,$cm) {
        global $CFG;
        $linkname = "<img src=\"$CFG->wwwroot/mod/resource/icon.gif\" align=\"top\" alt=\"\"/>&nbsp;<span>".$tree->name."</span>";
        $buttonarray = array();
        $buttonarray[] = $mform->createElement('image',"move[$cm->id]","$CFG->wwwroot/pix/t/move.gif");
        $buttonarray[] = $mform->createElement('image',"edit[$cm->id]","$CFG->wwwroot/pix/t/edit.gif");
        $buttonarray[] = $mform->createElement('image',"delete.[$cm->id]","$CFG->wwwroot/pix/t/delete.gif");
        if($cm->visible){
            $buttonarray[] = $mform->createElement('image',"hide[$cm->id]","$CFG->wwwroot/pix/t/hide.gif");
        }else{
            $buttonarray[] = $mform->createElement('image',"show[$cm->id]","$CFG->wwwroot/pix/t/show.gif");
        }
        $mform->addGroup($buttonarray, 'editbutton', $linkname, array(' '), false);
        $mform->setType('editbutton', PARAM_RAW);
    }
    
    function add_saveback_buttons(&$mform) {

        $buttonarray[] = $mform->createElement('submit', 'saveback', get_string("parent","resource"));
        $mform->addGroup($buttonarray, 'buttonar', $linkname, array(' '), false);
        $mform->setType('buttonar', PARAM_RAW);
        $mform->closeHeaderBefore('buttonar');
    }

    function tree_print_header($course,$fromform,$parent){
        global $CFG, $RESOURCE_WINDOW_OPTIONS;
        $streditinga = get_string("editinga", "moodle", "resource");
        $strmodulenameplural = get_string("modulenameplural", "resource");
        
        $this->singlecolon($parent);
        $treeids = explode(":",$parent);
        
        $navlinks = array();
        $navlinks[] = array('name' => $strmodulenameplural, 'link' => "$CFG->wwwroot/mod/resource/index.php?id=$course->id", 'type' => 'activity');
        foreach($treeids as $treeid){
            if($treeid){
                $cm = get_record("course_modules","id",trim($treeid));
                $tree = get_record("resource","id",$cm->instance);
                $this->quote_decode($tree);
                $navlinks[] = array('name' => $tree->name, 'link' => "", 'type' => 'activity');//"$CFG->wwwroot/course/modedit.php?add=resource&section=$fromform->section&course=$course->&parent=$parent", 'type' => 'activity');
            }
        }
        $navlinks[] = array('name' => $streditinga, 'link' => '', 'type' => 'title');

        $navigation = build_navigation($navlinks);

        print_header_simple($streditinga, '', $navigation,"", "", false);

        $icon = '<img src="'.$CFG->modpixpath.'/resource/icon.gif" alt=""/>';
        if($parent){
            print_heading_with_help(get_string("addlink","resource"), "mods", "resource", $icon);
        }else{
            print_heading_with_help(get_string("resourcetypetree","resource"), "mods", "resource", $icon);
        }
    }

    function reset_mform(&$mform){
        unset($mform->_elements);
        unset($mform->_elementIndex);
    }


    function quote_replace(&$ary){
        $ary->name = str_replace("'","&#039;",$ary->name);
        $ary->alltext = str_replace("'","&#039;",$ary->alltext);        
        return $ary;
    }
    function quote_decode(&$ary){
        $ary->name = htmlspecialchars_decode($ary->name, ENT_QUOTES);
        $ary->alltext = htmlspecialchars_decode($ary->alltext, ENT_QUOTES);
        $ary->alltext = str_replace(":<!-- set -->:","",$ary->alltext);
        $ary->alltext = str_replace("<!-- set -->:","",$ary->alltext);
        $ary->alltext = str_replace("<!-- set -->","",$ary->alltext);
        return $ary;
    }

    //object($_POST)
    function tree_get_postdata($data){
        if($data){
            foreach($data as $key=>$d){
                $value->$key = $data[$key];
            }
            return $value;
        }else{
            return false;
        }
    }
    
    function tree_hidden_coursemodule_elements(&$mform){
        //$mform =& $this->_form;
        $add           = optional_param('add', 0, PARAM_ALPHA);
        $update        = optional_param('update', 0, PARAM_INT);
        //$updatetree        = optional_param('updatetree', 0, PARAM_INT);
        $return        = optional_param('return', 0, PARAM_BOOL); //return to course/view.php if false or mod/modname/view.php if true
        $type          = optional_param('type', '', PARAM_ALPHANUM);
        $section = optional_param('section', PARAM_INT);
        $course = optional_param('course', PARAM_INT);
        $module = get_record("modules", "name", $add);
        
        $mform->addElement('hidden', 'course', 0);
        $mform->setType('course', PARAM_INT);
        $mform->setDefault('course', $course);
        
        
        $mform->addElement('hidden', 'section', 0);
        $mform->setType('section', PARAM_INT);
        $mform->setDefault('section', $section);

        $mform->addElement('hidden', 'module', 0);
        $mform->setType('module', PARAM_INT);
        $mform->setDefault('module', $module->id);

        $mform->addElement('hidden', 'modulename', '');
        $mform->setType('modulename', PARAM_SAFEDIR);
        $mform->setDefault('modulename', $module->name);
        
        $mform->addElement('hidden', 'coursemodule', 0);
        $mform->setType('coursemodule', PARAM_INT);     
        $cm = get_record("course_modules", "id", $update);
        if($update && $cm){
            $mform->setDefault('coursemodule', $cm->id);
            $mform->setDefault('course', $cm->course);
        }

        $mform->addElement('hidden', 'add', 0);
        $mform->setType('add', PARAM_ALPHA);
        $mform->setDefault('add', $add);

        $mform->addElement('hidden', 'update', 0);
        $mform->setType('update', PARAM_INT);
        //$mform->setDefault('update', $update);
        
        $mform->addElement('hidden', 'updatetree', 0);
        $mform->setType('updatetree', PARAM_INT);


        $mform->addElement('hidden', 'return', 0);
        $mform->setType('return', PARAM_BOOL);
        $mform->setDefault('return', $return);
    }
    
    function singlecolon(&$text){
        while(strpos($text,"::")){
            $text = str_replace("::",":",$text);
        }
    }

}
?>